# [Provisioning](./)

Managing Infrastructure for Services and Tasks under own control and needs in declarative and sustainable mode with **T-rust**

<img style="margin: 1em 0em;border: 0" width="300" alt="Provisioning" src="images/provisioning_logo-light.svg?sanitize=true">

--- 

> Infrastructure and Services Provisioning Tool Core and TaskServices, fully oriented to a "private and self hosted infrastructure" for developments and deployments, addressing services/projects life cycles in Declarative mode by following IaC, GitOps, CD/CI principles under a DevOps culture.  
> [Doc Server](./) is a **Web Server** in [Rust](https://www.rust-lang.org) for [static content](./docs/static_content.md)
with **Control access**  via [authorizations](./docs/auths.md), fully customizable with [settings](./docs/settings.md).

> [!WARNING]
> Code here needs a fulll review and documentation and will be presented soon

 ## Features

Managing Infrastructure for Services/Tasks in declarative, customizable and sustainable mode with **T-rust**

- <a target="_blank" href="https://nushell.sh">Nushell</a> a Rust tool for easy t-rust-ed composition, included parsing tools and output look and feel in Opertions 
- <a target="_blank" href="https://kcl-lang.io">KCL</a> for static type and contraints Opertions states declarations-definitions (IaC mode) [what]
- <a target="_blank" href="https://github.com/getsops/sops">SOPS</a> to secure encrypt credentials and certs (GitOps, CDCI modes) via several providers [safety]
- **Providers** and their resources can be plugged, mixted and used via their CLI or API for operations. Local, UpCloud and AWS tested by now
- **Servers** operations can be run in parallel
- **Tasks/Services** can be defined and attached to hosts independly, with different profiles and executed in several **run modes** to adjust specific contexts and needs
- **Cluster** operations for resources under containers services like Podman or Kubernetes, using tailored profiles and **run modes**
-  **Templating engine** <a target="_blank" href="https://keats.github.io/tera">Tera</a> to customize operations with definitions settings
- **Basic help** to run commands and request, improve usability and look & feel
- **Instrospection and naviation views** to inspect environments, resources, logs and debug
- **Encryption handling** can manage definitions and settings encrypt/decrypt on the fly
- **Setup, Context, Tools** handling for configuration, install, updates, etc housekeeping tasks
- **Generate Provisioning targets** from templates o blueprints with simple and minumum settings from config file or via prompt
- **Provisioning Web UI** addon in <u>Wasm</u> connecting to CLI for operations, allows remote view and management with friendly interface using drag-drop and clipboard copy & paste

